<?php

/**
 * Cargo Logic
 *
 * @package Logic
 *
 * @author  luistavares 04/08/2011
 *
 */
class CargoLogic{

    const ERRO_NOVOMESTRE = 'Ocorreu um erro ao gerar o mestre!';
    const ERRO_DESTROIMESTRE = 'Ocorreu um erro ao apagar o mestre!';


    /**
     * Gera um novo Cargom para o registro que est sendo inserido em GPE_CARGOH.
     *
     * @param integer $nrorgTrab Nr Org.
     *
     * @return integer
     *
     * @author  luistavares 04/08/2011
     */
    public function criaMestre($nrorgTrab){
        try{
            $nrcargom = rand(1, 100000);
            $cargo = new GpeCargomEntity;

            $mestre_incluido = $cargo->novoMestre($nrcargom, $nrorgTrab);
            if ($mestre_incluido === true) {
                return $nrcargom;
            } else {
                return $this::ERRO_NOVOMESTRE;
            }
        }
        catch(Exception $e){
            return $this::ERRO_NOVOMESTRE;
        }
    }


    /**
     * Verifica se o registro esta sendo apagado ou alterado e destroi o Cargom, caso necessario.
     *
     * @param integer $nrcargom  Nr Cargo Mestre.
     * @param integer $nrcargoh  Nr Cargo Historico.
     * @param integer $nrorgTrab Nr Org.
     *
     * @return integer
     *
     * @author  luistavares 05/08/2011
     */
    public function destroiMestrePosCancelamento($nrcargom, $nrcargoh, $nrorgTrab){
        try{
            $cargo = new GpeCargomEntity;
            $historico = $cargo->retornaCargoHistorico($nrcargom, $nrcargoh, $nrorgTrab);

            if (is_object($historico) === true) {
                return true;
            } else {
                $mestre_excluido = $cargo->destroiMestre($nrcargom, $nrorgTrab);
                if ($mestre_excluido === true) {
                    return true;
                } else {
                    return $this::ERRO_DESTROIMESTRE;
                }
            }
        }
        catch(Exception $e){
            return $this::ERRO_DESTROIMESTRE;
        }
    }


    /**
     * Destroi o Cargom do registro que est sendo apagado de GPE_CARGOH.
     *
     * @param integer $nrcargom  Nr cargo.
     * @param integer $nrorgTrab Nr Org.
     *
     * @return boolean
     *
     * @author luistavares 05/08/2011
     */
    public function destroiMestre($nrcargom, $nrorgTrab){
        try{
            $cargo = new GpeCargomEntity();
            tk_delete_row();
            $mestre_excluido = $cargo->destroiMestre($nrcargom, $nrorgTrab);
            if ($mestre_excluido === true) {
                return true;
            } else {
                return $this::ERRO_DESTROIMESTRE;
            }
        }
        catch(Exception $e){
            return $this::ERRO_DESTROIMESTRE;
        }
    }


}