var Bco01400_RecalculoLancamentoContaCorrente_Service = function(Bco01400_RecalculoLancamentoContaCorrente_Repository) {
  
  this.buildDataSourceFromParams = function (params) {
    
    var dataSourceFilter = [];
    
    for(var param in params) {
      dataSourceFilter.push(
        {
          "name": param,
          "operator": "=",
          "value": params[param]
        }
      );
    }
    
    return dataSourceFilter;
    
  };
  
  this.buildParamsAccordingToFilter = function(currentFilter) {
    
    var params = {};
    
    //Lançamentos
    params.P_DEBCRED = currentFilter.P_DEBCRED;
    params.P_TIPO = "";
    if (typeof currentFilter.P_TIPOCRED instanceof Array) {
      if (currentFilter.P_TIPOCRED.length > 0)
        params.P_TIPO += currentFilter.P_TIPOCRED.join(" ");
    } 
    if (currentFilter.P_TIPODEB instanceof Array) {
      if(currentFilter.P_TIPODEB.length > 0)
        params.P_TIPO += currentFilter.P_TIPODEB.join(" ");
    }
    if (params.P_TIPO === ""){
      params.P_TTIPO = 'T';
    }
    
    //Valores
    if (valueRangeIsNotDefined(currentFilter)) {
      params.P_TVRMOVI = 'T';
    } else {
      params.P_TVRMOVI = ' ';
      params.P_VRINI = currentFilter.P_VRINI;
      params.P_VRFIN = currentFilter.P_VRFIN;
    }
    
    //Data
    if (datePeriodIsNotDefined(currentFilter)) {
      params.DTTODOS = 'T';
    } else {
      params.DTTODOS = ' ';
      params.P_DATAINI = currentFilter.DTBTMOVICRED.start+' 00:00:00';
      params.P_DATAFIN = currentFilter.DTBTMOVICRED.end+' 00:00:00';
    }
    
    params.CODIGO = currentFilter.CDREDUCONT;
    
    return params;
    
  };
  
  this.validateCheckedRow = function(row) {
    return Bco01400_RecalculoLancamentoContaCorrente_Repository.validateCheckedRow(row);
  };
  
  this.validateCheckedRows = function(checkedRows) {
    return Bco01400_RecalculoLancamentoContaCorrente_Repository.validateCheckedRows(checkedRows);
  };
  
  this.recontabilizarLancamentos = function(rows) {
    return Bco01400_RecalculoLancamentoContaCorrente_Repository.recontabilizarLancamentos(rows);
  };
  
  var valueRangeIsNotDefined = function(filter) {
    return !(filter.P_VRINI && filter.P_VRFIN);
  };
  
  var datePeriodIsNotDefined = function(filter) {
    if (filter.DTBTMOVICRED && filter.DTBTMOVICRED) {
      return !(filter.DTBTMOVICRED.end && filter.DTBTMOVICRED.start);
    } else {
      return true;
    }
  };
  
};

Configuration(function (ContextRegister){
    ContextRegister.register('Bco01400_RecalculoLancamentoContaCorrente_Service', Bco01400_RecalculoLancamentoContaCorrente_Service);
});