function Pag11004_RelatorioCustomizavelRateiosTitulosPagarPagos_Controller(General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, restEngine) {
    
    var self = this;
    
    self.openFilterTitulosAPagar = function(widgetTitulosAPagar){
        self.buscaDadosIniciaisFiltro(widgetTitulosAPagar).then(function(){
            var rowSetFilter = {
                'DTVENBOLPAG' : widgetTitulosAPagar.DTVENBOLPAG,
                'CDEMPRESA'   : widgetTitulosAPagar.empresa.CDEMPRESA,
                'NMEMPRESA'   : widgetTitulosAPagar.empresa.NMEMPRESA
            };
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
            
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAPagar) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAPagar).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAPagar).then(function(){
                deferred.resolve();
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa_filial_filioper';
            var filterEmpresa = [
                {"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA},
                {"name": "CDOPERADOR", "operator": "=", "value": getLocalVar('CDOPERADOR')}
            ];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa_filial_filioper[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaGeralPag = function(){
        return General.callRestEngine(
            'fin#/crud/geral_pag',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        ); 
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralpag     = self.buscaGeralPag();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralpag, paramestoque]).then(function(response){
            geralpag     = response[0].dataset.geral_pag[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralpag?geralpag.QTDIAANTBOLP?geralpag.QTDIAANTBOLP:0:0;
            var qtdiaapolanr = geralpag?geralpag.QTDIAAPOBOLP?geralpag.QTDIAAPOBOLP:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            widget.DTVENBOLPAG = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Pag11004_RelatorioCustomizavelRateiosTitulosPagarPagos_Controller', Pag11004_RelatorioCustomizavelRateiosTitulosPagarPagos_Controller);
});